<?php
/**
 * BitTools Platform | B2W - Companhia Digital
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @category  BitTools
 * @package   BitTools_SkyHub
 *
 * @copyright Copyright (c) 2018 B2W Digital - BitTools Platform.
 *
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace BitTools\SkyHub\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

interface CustomerAttributeMappingOptionsRepositoryInterface
{
    /**
     * Retrieve all attributes for entity type
     *
     * @param SearchCriteriaInterface $searchCriteria
     *
     * @return mixed
     */
    public function getList(SearchCriteriaInterface $searchCriteria);


    /**
     * @param $mappingId
     *
     * @return mixed
     */
    public function get($mappingId);


    /**
     * @param Data\CustomerAttributeMappingOptionsInterface $mapping
     *
     * @return mixed
     */
    public function save(Data\CustomerAttributeMappingOptionsInterface $mapping);


    /**
     * @param Data\CustomerAttributeMappingOptionsInterface $mapping
     *
     * @return mixed
     */
    public function delete(Data\CustomerAttributeMappingOptionsInterface $mapping);


    /**
     * @param int $mappingId
     *
     * @return mixed
     */
    public function deleteById($mappingId);
}
